Enable or disable a coupon - Fabric

Enable or disable a coupon

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '\n{\n  "isEnabled": false\n}\n'  

Python

import requests

url = "https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle"

payload = { "isEnabled": False }
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({isEnabled: false})
};

fetch('https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    'isEnabled' => false\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json",\
    "x-fabric-tenant-id: <x-fabric-tenant-id>"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle"

payload := strings.NewReader("{\n  \"isEnabled\": false\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Unirest (Java)

HttpResponse<String> response = Unirest.post("https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle")
  .header("x-fabric-tenant-id", "<x-fabric-tenant-id>")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"isEnabled\": false\n}")
  .asString();

Ruby

require 'uri'
require 'net/http'

url = URI("https://api.fabric.inc/v3/coupons/{couponId}/actions/toggle")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-fabric-tenant-id"] = '<x-fabric-tenant-id>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"isEnabled\": false\n}"

response = http.request(request)
puts response.read_body

Response Codes


Error Responses

{
  "type": "PROMO_NOT_IN_DISABLED_STATUS",
  "message": "Promotion can't be activated if it's not DISABLED"
}
{
  "type": "UNAUTHORIZED",
  "message": "Invalid credentials"
}
{
  "type": "PROMOTION_NOT_FOUND",
  "message": "The promotion you entered doesn't exist"
}
{
  "type": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error"
}

Request Body

{
  "isEnabled": false
}

Example Response

{
  "id": "6380e7ecb419a30009865fad",
  "name": "Christmas 2022 coupons",
  "status": "DISABLED",
  "startAt": "2022-08-24T14:15:22.000Z",
  "endAt": "2019-08-25T14:15:22.000Z",
  "type": "PRODUCT",
  "createdAt": "2019-08-20T14:15:22.000Z",
  "updatedAt": "2019-08-20T14:15:22.000Z",
  "couponCodesCount": 100,
  "level": 3,
  "stackingType": "STACKABLE",
  "isStackable": false,
  "isAlwaysApplied": false,
  "singleMultiUse": "MULTI_USE",
  "couponCodes": ["SUMMER1000001"],
  "promotionMessages": [{"title": "Buy 2 get 1 free", "message": "Offer valid at participating stores through September 5, 2023.", "pages": ["PDP", "Cart"], "locales": ["en-CA", "fr-CA"]}],
  "additionalAttributes": [{"name": "type", "values": "Birthday", "attributeId": 100000}]
}